/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef BENESWIN_H_DEFINED
#define BENESWIN_H_DEFINED

#include <interface/Window.h>
#include <interface/Bitmap.h>
#include "NesDisplay.h"
#include "NesJoypad.h"

class BeNESWin: public BWindow,
                public NesDisplay {
	BBitmap* mOffscreen;	
	BView* mView;
	uint32 IndexPalette[256];
	enum { X=100, Y=100, W=256, H=240 };
	uchar* mBits;
	int mBytesPerRow;
	BMenuBar* mMenubar;
	bigtime_t mFrameSnooze;
public:
	BeNESWin();
	bool QuitRequested();
	BMenuBar* getMenubar() { return mMenubar; }
	BMenu* getSkipFramesMenu();
	BMenu* getFramesParSecMenu();
	BMenu* getSoundMenu();
	BMenu* getInputMenu();
	void updateScreen(const NesVirtualScreen* screen, bool draw);
	void setFPS(int fps);
	void clear() { Lock(); mView->Invalidate(); Unlock(); }
};

#endif
