#ifndef FILEEXCEPTION_H_DEFINED
#define FILEEXCEPTION_H_DEFINED

#include <stdexcept>

class FileOpenError: public std::runtime_error {
public:
	FileOpenError(const string what_arg=""):
		std::runtime_error(what_arg) { ; }
};

class FileIOError: public std::runtime_error {
public:
	FileIOError(const string what_arg=""):
		std::runtime_error(what_arg) { ; }
};

class FileReadError: public FileIOError {
public:
	FileReadError(const string what_arg=""):
		FileIOError(what_arg) { ; }
};

class FileWriteError: public FileIOError {
public:
	FileWriteError(const string what_arg=""):
		FileIOError(what_arg) { ; }
};


#endif
