#ifndef NESEXCEPT_H_DEFINED
#define NESEXCEPT_H_DEFINED

#include <stdexcept>

namespace Nes {
#include "FileException.h"

class UnknownFormat: public std::runtime_error {
public:
	UnknownFormat(const string what_arg=""):
		std::runtime_error(what_arg) { ; }
};

class UnknownMapper: public std::runtime_error {
	int mMapper;
public:
	UnknownMapper(const int mapper, const string what_arg=""):
		std::runtime_error(what_arg),
		mMapper(mapper) { ; }
	int mapper() { return mMapper; }
};

}

#endif
