/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
// The IO Port 
//
#include "NesIO.h"
#include <string.h>

/*------------------------------------- ROM Cartridge Initialize ---*/
void NesIO::ROM_Init(uchar* ram)
{
	mPPU->init();
	if (mROM->isVerticalMirror()) {
		mPPU->setMirrorType(PPU_MIRROR_VERTICAL);
	}
	else {
		mPPU->setMirrorType(PPU_MIRROR_HORIZONTAL);
	}
	mROM->init(this);
}

/*----------------------------------- ROM Cartridge UnInitialize ---*/
void NesIO::ROM_UnInit(uchar* ram)
{
	mROM->uninit(this);
}
