/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
// Main board
//
#include "NesMainboard.h"

//-------------------------------------------------------------
void NesMainboard::insertROM(NesROM* rom)
{
	// Connect To IOPort
	mIO.connect(rom);
}

//-------------------------------------------------------------
void NesMainboard::connectDisplay(NesDisplay* display)
{
	// Connect To PPU
	mPPU.connect(display);
}

//-------------------------------------------------------------
void NesMainboard::enableSound(bool on)
{
	mAPU.enableSound(on);
}

//-------------------------------------------------------------
void NesMainboard::connectJoypad(NesJoypad* joypad)
{
	// Connect To IOPort
	mIO.connect(joypad);
}

//-------------------------------------------------------------
void NesMainboard::run()
{
	// Runs NES Systems
	if (mIO.ROM_IsConnected()) {
		mCPU.reset();
		mCPU.run();
	}
}

//-------------------------------------------------------------
void NesMainboard::stop()
{
	// Stop NES Systems
	mCPU.stop();
}
