/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
// Mainboard
//
#ifndef NESMAINBOARD_H_DEFINED
#define NESMAINBOARD_H_DEFINED

#include "NesCPU.h"
#include "NesPPU.h"
#include "NesAPU.h"
#include "NesROM.h"
#include "NesIO.h"

class NesDisplay;
class NesJoypad;

class NesMainboard {
	NesPPU mPPU;
	NesAPU mAPU;
	NesIO mIO; 
	NesCPU mCPU;
public:
	NesMainboard():
		mPPU(),
		mAPU(),
		mIO(&mPPU, &mAPU),
		mCPU(&mIO) { ; }
	void insertROM(NesROM* rom);
	void run();
	void stop();
	void connectDisplay(NesDisplay* display);
	void connectJoypad(NesJoypad* joypad);
	void enableSound(bool on);
	void setSkipFrames(int skip) { mPPU.setSkipFrames(skip); }
};

#endif
