/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef NESSCREENINFO_H_DEFINED
#define NESSCREENINFO_H_DEFINED

#include "NesTypes.h"

struct NesRenderInfo {
	int shift;
	int nametbl_index;
	int attrtbl_index;
};

class NesScreenRenderInfo {
	enum {
		W = NesVirtualScreen::Width,
		H = NesVirtualScreen::Height
	};
	NesRenderInfo mXY[H][W];
	uchar mTilePattern[256][8];
public:
	NesScreenRenderInfo();
	int nametbl(int base, int top, int left) {
		return (base + mXY[top][left].nametbl_index);
	}
	int attrtbl(int base, int top, int left) {
		return (base + mXY[top][left].attrtbl_index);
	}
	int shift(int top, int left) {
		return mXY[top][left].shift;
	}
};

#endif
